<?PHP

   $cYear = date("Y");

   $_ACTION_FILE_name_ = $_SERVER['SCRIPT_NAME'];

   $init  = trim(@$_POST["init"]);

   $out = "";

// -----------------------------------------------
// If NOT initialized yet, then set default values
// and mark as initialized.

   if ($init == "")
      {
       $RA1      = "6 45 08.9";
       $Dec1Sign = "-";
       $dec1     = "16 42 58";
       $dist1    = "8.6";
       $VisMag1  = "-1.46";

       $RA2      = "18 36 56.3";
       $Dec2Sign = "+";
       $dec2     = "38 47 01";
       $dist2    = "25.3";
       $VisMag2  = "+0.03";

       $init = "TRUE"; // Now initialized.
      }

   else


// Otherwise, read interface values.

      {
       $RA1      = trim(@$_POST["RA1"]);

       $Dec1Sign = trim(@$_POST["Dec1Sign"]);

       if ($Dec1Sign != "-")
          {
           $Dec1Sign = "+";
           $Dec1SignNum = 1;
          }
       else
          {
           $Dec1SignNum = -1;
          }

       $dec1     = trim(@$_POST["dec1"]);
       $dist1    = trim(@$_POST["dist1"]);
       $VisMag1  = trim(@$_POST["VisMag1"]);





       $RA2      = trim(@$_POST["RA2"]);

       $Dec2Sign = trim(@$_POST["Dec2Sign"]);
       if ($Dec2Sign != "-")
          {
           $Dec2Sign = "+";
           $Dec2SignNum = 1;
          }
       else
          {
           $Dec2SignNum = -1;
          }

       $dec2     = trim(@$_POST["dec2"]);
       $dist2    = trim(@$_POST["dist2"]);
       $VisMag2  = trim(@$_POST["VisMag2"]);



// Prepare values for computations.

//   DMS_To_Deg ($SignNumArg, $DMSarg)

   $RA1Deg  = HMS_To_Deg (1, $RA1);
   $RA1Hrs  = $RA1Deg / 15;
   $Dec1Deg = DMS_To_Deg ($Dec1SignNum, $dec1);


   $RA2Deg  = HMS_To_Deg (1, $RA2);
   $RA2Hrs  = $RA2Deg / 15;
   $Dec2Deg = DMS_To_Deg ($Dec2SignNum, $dec2);


// Format to 10 decimals
   $RA1Deg  = sprintf("%1.10f", $RA1Deg);
   $RA1Hrs  = sprintf("%1.10f", $RA1Hrs);
   $DecDeg  = sprintf("%1.10f", $Dec1Deg);
   $RA2Deg  = sprintf("%1.10f", $RA2Deg);
   $RA2Hrs  = sprintf("%1.10f", $RA2Hrs);
   $Dec2Deg = sprintf("%1.10f", $Dec2Deg);


// ($PosSignFlag, $DegArg, $hhDigits, $ssDecimals, $SymbolsFlag=TRUE)


// Compute distance between the stars.

   $D = Dist_Bet_Stars ($RA1Deg, $Dec1Deg, $dist1, $VisMag1, $RA2Deg, $Dec2Deg, $dist2, $VisMag2);

   $out .= $D;




      }





print <<< _HTML

<!DOCTYPE HTML>

<HTML lang='en'>

<HEAD>

<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">

<TITLE>Distance Between Two Stars or Planets in 3D Space</TITLE>
<meta name='viewport' content='width=device-width, initial-scale=1'>
<meta http-equiv='content-type' content='text/html; charset=UTF-8'>
<meta name='description' content='Distance Between Two Stars or Planets in 3D Space'>
<meta name='keywords' content='distance between stars,distance between planets,distance between 3D points in space'>
<meta name='author' content='Jay Tanner - PHPScienceLabs.com'>
<meta http-equiv='pragma'  content='no-cache'>
<meta http-equiv='expires' content='-1'>
<meta name='robots'    content='index,follow'>
<meta name='googlebot' content='index,follow'>
<link rel="canonical" href="https://www.phpsciencelabs.com/distance-between-two-stars-or-planets-calculator/">

<style type='text/css'>
BODY {color:white; background-color:black; font-family:Verdana; padding:2px;}

TABLE {color:white; background-color:black; font-family:Verdana; font-size:12px; line-height:150%; padding:4px; border:1px solid black; border-radius:6px;}

TD {color:black; background-color:white; font-family:Verdana; font-size:15px; text-align:center; border:1px solid black; padding:4px;}

PRE, CODE {font-family:monospace; font-size:18px; font-weight:bold; background-color:white; padding:4px; text-align:left;}

CODE {font-family:monospace; padding:0px;}

HR {height:2px; background-color:black; border:0px;}

INPUT[type="text"] {font-family:monospace; font-size:20px; font-weight:bold; text-align:center; border:2px solid black; border-radius:4px;}

INPUT[type="text"]:focus {background-color:white; font-family:monospace; font-size:20px; font-weight:bold; text-align:center; border:2px solid blue; border-radius:4px;}

INPUT[type="text"]::-ms-clear {width:0; height:0;}

A:link {color:blue; background-color:transparent; font-family:Verdana; font-size:12px; font-weight:bold; text-decoration:none; line-height:150%; padding:2px;}

A:visited {color:blue; background-color:transparent; font-family:Verdana; font-size:12px; font-weight:bold; text-decoration:none; line-height:150%; padding:2px;}

INPUT[type="submit"]{font-weight:bold;}

INPUT[type="submit"]:hover{box-shadow:2px 2px 5px #222222; font-weight:bold;}

IMG {box-shadow:2px 2px 5px #222222; border:1px solid black; border-radius:6px;}

::selection {color:black; background-color:yellow;}  /* Only affects IE9+/Safari */
::-moz-selection {color:black; background-color:yellow;}  /* Only affects FireFox/Mozilla */
</style>

</head>

<body style='background-color:black;'>

<form name="form1" method="post" action="$_ACTION_FILE_name_">

<table width="1024" cellpadding="6" cellspacing="0" style='font-size:14px;' align='top'>

<tr><td colspan="5" align="center" style='background-color:#000066; color:white; font-size:150%; border:2px solid white; border-radius:8px 8px 0px 0px;'>Distance Between Two Stars or Planets in 3D Space<br><span style='font-size:65%;'>PHP Program by Jay Tanner</span</td></tr>

<tr>
<td bgcolor="white">&nbsp;</td>
<td style="background-color:LightCyan; font-size:12px;"><b>Right&nbsp;Ascension&nbsp;(H&nbsp;M&nbsp;S&nbsp;&nbsp;or&nbsp;H.hhh)</b> </td>
<td style="background-color:LightCyan; font-size:12px;"><b>Declination&nbsp;(D&nbsp;M&nbsp;S&nbsp;&nbsp;or&nbsp;D.ddd)</b> </td>
<td style="background-color:GreenYellow; font-size:12px;"><b>Dist&nbsp;&nbsp;&nbsp;LY/AU</b></td>
<td style="background-color:DarkBlue; color:white; font-size:12px;"><b>Vis Mag </b></td>
</tr>

<tr>
<td bgcolor="LightCyan" width="52"><b>1</b><sup>st</sup>&nbsp;<b>Body</b> </td>
<td bgcolor="silver"><input name="RA1" type="text" value="$RA1" size="21" maxlength="20"></td>
<td bgcolor="LightGrey"><input name="Dec1Sign" type="text" value="$Dec1Sign" size="1" maxlength="1">
<input name="dec1" type="text" value="$dec1" size="17" maxlength="16"></td>
<td bgcolor="silver"><input name="dist1" type="text" value="$dist1" size="9" maxlength="8"></td>
<td bgcolor="silver"><input name="VisMag1" type="text" value="$VisMag1" size="8" maxlength="7"></td>
</tr>

<tr>
<td bgcolor="LightCyan" width="52"><b>2</b><sup>nd</sup>&nbsp;<b>Body</b> </td>
<td bgcolor="silver"><input name="RA2" type="text" value="$RA2" size="21" maxlength="20"></td>
<td bgcolor="LightGrey"><input name="Dec2Sign" type="text" value="$Dec2Sign" size="1" maxlength="1">
<input name="dec2" type="text" value="$dec2" size="17" maxlength="16"></td>
<td bgcolor="silver"><input name="dist2" type="text" value="$dist2" size="9" maxlength="8"></td>
<td bgcolor="silver"><input name="VisMag2" type="text" value="$VisMag2" size="8" maxlength="7"></td>
</tr>

<tr>

<td colspan="5"><input name="init" type="hidden" value="$init" size="4" maxlength="3">

<input type="submit" name="Submit" value="Compute"></td>
</tr>

<tr>
<td colspan="5" bgcolor="white" align='center' style='font-size:90%;'>
<pre style='font-size:18px; background-color:LightYellow; border:2px solid black; text-align:left; border-radius:8px; padding:8px;'>$out</pre>
NOTE: Decimal RA and declination arguments may also be used: e.g., <code>06 33 27</code> is equivalent to <code>6.5575</code><br><br></td>
</tr>

<tr><td colspan="5" style='font-size:14px; text-align:justify;'>
<div>

<b>Computing the Distance Between Two Stars or Planets</b>
<br><br>
In this case of computing the distance between two stars or planets, we are treating the bodies as simple points in 3D space.&nbsp; So, finding the distance between them, becomes a simple matter of 3D trigonometry.

<br><br>
In astronomy, we generally give stars 3D spherical coordinates. &nbsp; They are the standard right ascension, declination and distance coordinates of the stars.&nbsp; On Earth we use longitude and latitude, in astronomy, we use right ascension and declination respectively as coordinates. &nbsp; These standard space coordinates are cataloged for many stars (Epoch <b>J2000</b> is used here) and they can be used for 3D computations to the extent of their accuracy.

<br><br>
The 3rd coordinate, the distance, is often symbolized by <b>R</b> because it represents the radius vector (radius of a sphere), the line directed between the eye and body.&nbsp; The coordinates are envisioned as a grid drawn on the surface of an infinitely large sphere with our eye at the center and the body at distance R from the eye with apparent longitude (right ascension) and latitude (declination) coordinates as viewed projected against the sphere.

<br><br>
From the spherical space coordinates (<b>&alpha;, &delta;, R</b>), we can compute the corresponding rectangular (<b>X, Y, Z</b>)<br>coordinates from which the linear spatial distance (<b>D</b>) between the two bodies can then be computed.
</div>

<br>

<div style='text-align:center;'>
<hr>
For any given star/planet, let:
<p><img SRC="images/variables_alpha_delta_R_D.png" alt=""><br><br></p>

Given the spherical (<b>&alpha;, &delta;, R</b>) coordinates of a planet or star, its corresponding<br>
rectangular (<b>X, Y, Z</b>) coordinates may be computed from:
<p><img src="images/spherical_to_rectangular.png" alt=""><br><br></p>

Given the spherical (<b>&alpha;</b>,<b>&delta;</b>,<b>R</b>) coordinates for two bodies, distinguished by subscripts,<br>to compute the distance between the bodies, we first compute their corresponding<br>rectangular (<b>X, Y, Z</b>) coordinates:

<p>For the first body:<br><img SRC="images/first_star_xyz.png" alt=""><br><br></p>
<p>For the second body:<br><img SRC="images/second_star_xyz.png" alt=""><br><br></p>

The distance (D) between the two bodies in XYZ-space may then be computed as the<br>
square root of the sum of the squares of the differences between their rectangular<br>
coordinates:
<p><img SRC="images/distance_between_two_stars.png" alt=""><br><br></p>

</div>

<br><br>
<div style='font-size:100%;'>
<hr>
<b>A Numerical Example - Part 1</b>:<br>
In this example we will compute the distance between the bright stars Sirius (= 1st Body) and Vega (= 2nd Body) and then compute how bright each star would appear to be from the perspective of the other.

<br><br><br>
This is the computational data pertaining to the stars used in the example:
<br>


<pre style='background-color:LightCyan; font-family:monospace; font-size:18px; border:2px solid black; border-radius:8px; padding:8px;'>
J2000.0 CATALOG DATA FOR SIRIUS AND VEGA AS VIEWED FROM EARTH/SUN
ASSUMED DISTANCE UNITS = LIGHT YEARS

--------  ---------------     ----------------   -------  -------
1ST STAR  RIGHT ASCENSION        DECLINATION       DIST   VIS MAG
 Sirius    06h 45m 08.9s       -16&deg; 42&#39; 58&quot;        8.6     -1.46
          101.2870833 deg      -16.7161111 deg

--------  ---------------     ----------------   -------  -------
2ND STAR  RIGHT ASCENSION        DECLINATION       DIST   VIS MAG
  Vega     18h 36m 56.3s       +38&deg; 47&#39; 01&quot;        25.3    +0.03
          279.2345833 deg      +38.7836111 deg
</pre>

Performing the distance computations for the given data (angles expressed in degrees):

<pre style='background-color:LightYellow; border:2px solid black; border-radius:8px; padding:8px;'>
<b>DISTANCE BETWEEN THE STARS SIRIUS AND VEGA

Rectangular Coordinates of Sirius:
x1 = 8.6 * Cos(101.2870833) * Cos(-16.7161111)  = -1.6121048578
y1 = 8.6 * Sin(101.2870833) * Cos(-16.7161111)  =  8.0772729746
z1 = 8.6 * Sin(-16.7161111)                     = -2.4736166278

Rectangular Coordinates of Vega:
x2 = 25.3 * Cos(279.2345833) * Cos(+38.7836111) =  +3.1648925282
y2 = 25.3 * Sin(279.2345833) * Cos(+38.7836111) = -19.4661817544
z2 = 25.3 * Sin(+38.7836111)                    = +15.8474358553

Rectangular Coordinate Differences:
dx = (x2 - x1) =  +4.7769973860
dy = (y2 - y1) = -27.5434547290
dz = (z2 - z1) = +18.3210524831

The distance (D) between the stars Sirius and Vega may
then be found from:

D = SqRoot(dx*dx + dy*dy + dz*dz) = 33.4233835290
  = About 33.42 light years between the stars.</b>
</pre>


<br><br>
<hr>
<b>APPARENT BRIGHTNESS</b>
<br><br>
Once we know the distance (<b>D</b>) between two bodies, we may then determine how bright each body would appear to be (ideally) as viewed from the other&#39;s perspective, as opposed to their apparent magnitudes as viewed from Earth.

<br><br>

<div style='text-align:center;'>
In this case, the general stellar magnitude vs. distance<br>
formula may be expressed as:
<p><img src="images/vis_mag_vs_D.png" alt=""><br><br></p>

Where:<br>

<b>m</b> = Visual magnitude of body as viewed from distance <b>d</b> in any units
<br>
<b>M</b> = Visual magnitude of body as viewed from distance <b>D</b> in any units
</div>

<br><br>
<b>d</b> and <b>m</b> respectively refer to the distance to and visual magnitude of one of the bodies as viewed from Earth.

<br><br>
<b>D</b> is the distance between the two bodies previously computed above.
<br>
<b>M</b> is the visual magnitude of one of the bodies at distance <b>D</b>.




<br><br>
The known values are (<b>d</b>, <b>m</b>, <b>D</b>) from which we compute <b>M</b> for each body.

<br><br>
<hr>
<b>Numerical Example Continued - Part 2</b>:
<br>

<pre style='background-color:LightYellow; font-size:18px; font-weight:bold; border:2px solid black; border-radius:8px; padding:8px;'>
From Sirius (Body 2) as viewed from Vega (Body 1):<br>
m = +0.03  = Magnitude of Vega as viewed from Earth
d = 25.3   = Distance to Vega from Earth in light years
D = 33.423 = Distance between Sirius and Vega in light years
M = Magnitude of Vega as viewed from Sirius

M = 5*Log10(D/d) + m

M = 5*Log10(33.423/25.3) + 0.03
  = 0.604625 + 0.03 = 0.634625

So, from Sirius, the magnitude of Vega would be +0.63


==============================================================
From Vega (Body 1) as viewed from Sirius (Body 2):

m = -1.46   = Magnitude of Sirius as viewed from Earth
d =  8.6    = Distance to Sirius from Earth in light years
D = 33.423  = Distance between Sirius and Vega in light years
M = Magnitude of Sirius as viewed from Vega

M = 5*Log10(D/d) + m

M = 5*Log10(33.423/8.6) + (-1.46)
  = 2.947735 - 1.46 = 1.487735

So, from Vega, the magnitude of Sirius would be +1.49

</pre>

</div>

<div style='font-size:70%; color:gray; text-align:center;'>Jay Tanner - $cYear</div>

</td></tr>


</table>
</form>

<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>
<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>

</body>
</html>


_HTML;




   function Dist_Bet_Stars ($RADegArg1, $DeclDegArg1, $DistArg1, $VMag1, $RADegArg2, $DeclDegArg2, $DistArg2, $VMag2)
{

   $w = "";

   $RA1   = Deg2Rad($RADegArg1);
   $RA1Hrs = $RADegArg1/15;
   $decl1 = Deg2Rad($DeclDegArg1);
   $R1    = $DistArg1;
   $x1 = $R1 * cos($RA1)*cos($decl1);
   $y1 = $R1 * sin($RA1)*cos($decl1);
   $z1 = $R1 * sin($decl1);

   $RA2   = Deg2Rad($RADegArg2);
   $RA2Hrs = $RADegArg2/15;
   $decl2 = Deg2Rad($DeclDegArg2);
   $R2    = $DistArg2;
   $x2 = $R2 * cos($RA2)*cos($decl2);
   $y2 = $R2 * sin($RA2)*cos($decl2);
   $z2 = $R2 * sin($decl2);


   $dx = $x2 - $x1;
   $dy = $y2 - $y1;
   $dz = $z2 - $z1;

   $D = SqRt($dx*$dx + $dy*$dy + $dz*$dz);


// Compute magnitude of Sirius from Vega.
   $M1 = 5*Log10($D/$R1) + $VMag1;


// Compute magnitude of Vega from Sirius.
   $M2 = 5*Log10($D/$R2) + $VMag2;




// Format output.
   $x1 = sprintf("%+1.10f", $x1);
   $y1 = sprintf("%+1.10f", $y1);
   $z1 = sprintf("%+1.10f", $z1);

   $x2 = sprintf("%+1.10f", $x2);
   $y2 = sprintf("%+1.10f", $y2);
   $z2 = sprintf("%+1.10f", $z2);

   $dx = sprintf("%+1.10f", $dx);
   $dy = sprintf("%+1.10f", $dy);
   $dz = sprintf("%+1.10f", $dz);

   $D  = sprintf("%1.3f", $D);

   $M1 = sprintf("%+1.3f", $M1);
   $M2 = sprintf("%+1.3f", $M2);

   $RADegArg1   = sprintf("%1.10f", $RADegArg1);
   $RA1Hrs   = sprintf("%1.10f", $RA1Hrs);
   $DeclDegArg1 = sprintf("%1.10f", $DeclDegArg1);
   $RADegArg2   = sprintf("%1.10f", $RADegArg2);
   $RA2Hrs   = sprintf("%1.10f", $RA2Hrs);
   $DeclDegArg2 = sprintf("%1.10f", $DeclDegArg2);



   $_BAR_ = str_repeat('=', 46);

 // Construct output.

   $w .= "STAR/BODY 1:\n\nRA<sub>1</sub>   =  $RADegArg1 deg = $RA1Hrs h\n";
   $w .= "Decl<sub>1</sub> = $DeclDegArg1 deg\n";
   $w .= "R<sub>1</sub>    = $R1\n\n";
   $w .= "x<sub>1</sub> = R<sub>1</sub>*cos(RA<sub>1</sub>)*cos(Decl<sub>1</sub>) = $x1\ny<sub>1</sub> = R<sub>1</sub>*sin(RA<sub>1</sub>)*cos(Decl<sub>1</sub>) = $y1\nz<sub>1</sub> = R<sub>1</sub>*sin(Decl<sub>1</sub>)          = $z1\n\n";
   $w .= "$_BAR_\nSTAR/BODY 2:\n\nRA<sub>2</sub>   = $RADegArg2 deg = $RA2Hrs h\n";
   $w .= "Decl<sub>2</sub> = $DeclDegArg2 deg\n";
   $w .= "R<sub>2</sub>    = $R2\n\n";

   $w .= "x<sub>2</sub> = R<sub>2</sub>*cos(RA<sub>2</sub>)*cos(Decl<sub>2</sub>) = $x2\ny<sub>2</sub> = R<sub>2</sub>*sin(RA<sub>2</sub>)*cos(Decl<sub>2</sub>) = $y2\nz<sub>2</sub> = R<sub>2</sub>*sin(Decl<sub>2</sub>)          = $z2\n\n";
   $w .= "$_BAR_\nRectangular Differences:\n\ndx = x<sub>2</sub> &minus; x<sub>1</sub>  = $dx\ndy = y<sub>2</sub> &minus; y<sub>1</sub>  = $dy\ndz = z<sub>2</sub> &minus; z<sub>1</sub>  = $dz\n\n";
   $w .= "$_BAR_\nDistance Between Bodies:\n\nD = SqRt(dx*dx + dy*dy + dz*dz) = $D\n\n";
   $w .= "$_BAR_\nMagnitude of 1st Body as Viewed From 2nd Body:\n\n";

   $w .= "m<sub>1</sub> = 5*Log10($D/$R1) + ($VMag1) = $M1\n\n";
   $w .= "$_BAR_\nMagnitude of 2nd Body as Viewed From 1st Body:\n\n";
   $w .= "m<sub>2</sub> = 5*Log10($D/$R2) + ($VMag2) = $M2\n\n";


   return $w;

}


// ************************************************************************
// ************************************************************************

/*

================================================
Compute decimal degrees corresponding to a given
space delimited DMS argument string.

This function is flexible and allows decimal
DMS values to be entered and non-standard
values outside the normal range, such as
90 seconds which would be treated as
equivalent to 00:01:30:00




=======
ERRORS:

On error, Boolean FALSE is returned.

*/


   function DMS_To_Deg ($SignNumArg, $DMSarg)

{

// Read numerical sign argument.
   $sign = ($SignNumArg < 0)? "-" : "+";

// ---------------------------
// Read input argument string.
   $DMS = trim($DMSarg);

// -------------------------------------------------
// Normalize spacing of the angle elements string to
// ensure only a single space between the elements.
   $DMS = preg_replace('/\s+/', ' ', trim($DMS));

// --------------------------------
// If input argument is empty, then
// use default "0 0 0" string.
   if ($DMS == "") {$DMS = "0 0 0";}

// -----------------------------
// Read angle elements and split
// into a work array.
   $DMS = preg_split ("[ ]", $DMS);

// ----------------------------------
// Count angle elements (n = 1 to 3).
   $n = count($DMS);

// ------------------------------------
// Fetch degrees value from work array.
   $dd = $DMS[0];

// ------------------------------------
// Fetch minutes value from work array.
   $mm = ($n > 1)?  $DMS[1] : 0;

// --------------------------------------
// Compute degrees equivalent to minutes.
   $mmd = bcDiv($mm, "60", 24);

// ------------------------------------
// Fetch seconds value from work array.
   if ($n > 2) {$ss = $DMS[2];} else {$ss = 0;}

// --------------------------------------
// Compute degrees equivalent to seconds.
   $ssd = bcDiv($ss, "3600", 24);

// -----------------------------------------------------
// Compute final decimal degrees rounded to
// 16 decimals, recalling numerical sign.
   $deg = $sign . bcRound(bcAdd_Seq("$dd $mmd $ssd", 24), 16);

// Patch to remove redundant negative sign.
   if ($deg == "-0") {$deg = "0";}

// -----
// Done.
   return $deg;

} // End of  DMS_To_Deg()




/*

This function takes an hour angle given in
any of several string formats and returns
the equivalent in decimal degrees.

It is the opposite of the Deg_To_HMS() function.

Assuming that ($HMSarg) is an hour angle given
in any of the following formats:

---------------------------------------
FORMAT       EXAMPLE     INTERPRETED AS

HH MM SS     1 2 3    =  01h 02m 03s
HH MM      -05 03     = -05h 03m 00s
HH           2        =  2h
HH MM.mm    12 1.25   =  12h 01m 15s
HH.hhhhh    18.555    =  18h 33m 18s

Where:
HH=Hours,  MM=Minutes,  SS=Seconds

------
ERRORS
On error, FALSE is returned.
An error results if any of the
angular elements are non-numeric.

*/


   function HMS_To_Deg ($SignNumArg, $HMSarg)
{

// -----------------------------------
// Read and remember numerical � sign.
   $sign = ($SignNumArg < 0) ?  "-" : "";

// -------------------------------------------------
// Normalize the spacing of the hour angle elements.
// There must be at least one space between each of
// the HH MM SS arguments as separators.
   $hms = preg_replace('/\s+/', ' ', trim($HMSarg));

// ----------------------------------------------
// Set empty angle string to default = 0 degrees.
   if ($hms == "") {$hms = 0;}
   $w = preg_split("[ ]", $hms);
   $AngleCount = count($w);

// --------------------------------------------
// Error if any angular element is non-numeric.
   if ($AngleCount >= 1)
      {if (!Is_Numeric($w[0])) {return FALSE;}}

   if ($AngleCount >= 2)
      {if (!Is_Numeric($w[1])) {return FALSE;}}

   if ($AngleCount >= 3)
      {if (!Is_Numeric($w[2])) {return FALSE;}}

// ----------------
// Read HMS values.
   if ($AngleCount >= 1) {$hh = $w[0];} else {$hh=0;}
   if ($AngleCount >= 2) {$mm = $w[1];} else {$mm=0;}
   if ($AngleCount >= 3) {$ss = $w[2];} else {$ss=0;}

// --------------------------------------------
// Compute total seconds per each time element.
   $hhss = bcMul($hh, "3600", 24);
   $mmss = bcMul($mm, "60",   24);
   $Tsec = bcAdd_Seq("$hhss $mmss $ss", 24);

// ---------------------------------------
// Compute decimal degrees to 16 decimals,
// recalling numerical sign.
   $deg = $sign . bcRound(bcDiv($Tsec, "240", 24), 16);
   if ($deg == "-0") {$deg = "0";}

// -----
// Done.
   return  $deg;

} // End of  HMS_To_Deg()



// =================================================
// This BC math function adds a sequence of numbers
// to the specified decimals of precision.
//
// Data string format = "1.1  2.22  3.333"
// Series of space-delimited numerical arguments
// to be summed.

   function bcAdd_Seq ($SeqStrArg, $NumDecimalsArg)

{

// ----------------------------------------------
// Remove redundant white space from data vector.

   $SeqStr = preg_replace('/\s+/', ' ', trim($SeqStrArg));

// -----------------------
// Get number of decimals.

   $d = trim($NumDecimalsArg);

// -----------------------------------------------
// Separate items to be summed into working array.

   $item = preg_split ("[ ]", trim($SeqStr));

// -------------------------
// Count items to be summed.

   $ItemCount = count($item);

// --------------------------------
// Handle case of empty items list.

   if ($ItemCount == 0) {return "0";}

// -----------------------------------
// Handle case of single item in list.

   if ($ItemCount == 1) {return $item[0];}

// -------------------
// Sum the items list.

   $sum = "0";

   for ($i=0;  $i < $ItemCount;   $i++)
       {
        $sum = bcAdd($sum, $item[$i], $d+8);
       }

   return bcAdd("0", $sum, $d);

} // End of  bcAdd_Seq()


/*

   This function rounds off a given decimal
   value to a given number of decimals.



   The rounding is absolute.

   The argument ($xStrArg) should be a numeric
   string, like "1.23456789"

*/

   function bcRound ($xStrArg, $NumDecimalsArg)

{
   $SignStr = (substr($xStrArg,0,1) == "-" )? "-" : "";

   $x = str_replace("-", "", $xStrArg);

   $decimals = $NumDecimalsArg;

   $Zeros5 = "";

   for ($i=0;   $i < $decimals;   $i++)
       {$Zeros5 .= "0";} $Zeros5 .= "5";

   $x = bcAdd($x, "0.$Zeros5", $decimals);

   return "$SignStr$x";
}




// ************************************************************************
// ************************************************************************


?>

